#ifndef VIEWERFOLDINGLIST_H
#define VIEWERFOLDINGLIST_H

// Extension of folding list to handle viewer specific drag and drop requests

#include <fx.h>

using namespace FX;

class ViewerFoldingList : public FXFoldingList
{
  FXDECLARE(ViewerFoldingList)
public:
  static FXDragType foldingItemType;
  static const FXchar foldingItemTypeText[];
protected:
  enum
  {
    DND_NONE=0,
    DND_TRYDRAG=1,
    DND_DRAG=2
  };
protected:
  FXuint dragmode_;
protected:
  ViewerFoldingList() { }
public:
  long onLeftBtnPress(FXObject*,FXSelector,void*);
  long onMiddleBtnPress(FXObject*,FXSelector,void*);
  long onLeftBtnRelease(FXObject*,FXSelector,void*);
  long onMiddleBtnRelease(FXObject*,FXSelector,void*);
  long onMotion(FXObject*,FXSelector,void*);
  long onBeginDrag(FXObject*,FXSelector,void*);
  long onEndDrag(FXObject*,FXSelector,void*);
  long onDragged(FXObject*,FXSelector,void*);
  long onDNDMotion(FXObject*,FXSelector,void*);
  long onDNDDrop(FXObject*,FXSelector,void*);
  long onDNDRequest(FXObject*,FXSelector,void*);
public:
  ViewerFoldingList(FXComposite *p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=FOLDINGLIST_NORMAL,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  virtual ~ViewerFoldingList() { }

  virtual void create();
};

#endif
