#ifndef FXOSGVIEWER_H
#define FXOSGVIEWER_H

#include <fx.h>
#include <fx3d.h>
#include <osgViewer/Viewer>

#include "GraphicsWindowFOX.h"

using namespace FX;

namespace osgFOX
{

class FXOSGViewer : public GraphicsWindowFOX, public osgViewer::Viewer
{
  FXDECLARE(FXOSGViewer)
protected:
  FXOSGViewer() { }
public:
  enum
  {
    ID_CANVAS = FXMainWindow::ID_LAST,
    ID_LAST
  };
public:
  long onPaint(FXObject*, FXSelector, void* data);
public:
  ///Constructor for canvas with a private display list.
  FXOSGViewer(FXComposite *p,FXGLVisual *vis,FXObject *tgt=NULL,FXSelector sel=0,FXuint opts=0,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  ///Constructor for canvas with a shared display list.
  FXOSGViewer(FXComposite *p,FXGLVisual *vis,FXGLCanvas *sharegroup,FXObject *tgt=NULL,FXSelector sel=0,FXuint opts=0,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  ///Virtual destructor.
  virtual ~FXOSGViewer();

  ///Standard FOX GUI create function.
  virtual void create();
};

}

#endif
