#ifndef VIEWBORDEROPERATION_H
#define VIEWBORDEROPERATION_H

#include <osgViewer/View>
#include "FXOSGCompositeViewer.h"

namespace osgFOX
{

struct ViewBorderOperation : public osg::Operation
{
  ViewBorderOperation(osgViewer::View* view, FXOSGCompositeViewer* compositeViewer)
  : osg::Operation("Render", true),
    _view(view),
    _compositeViewer(compositeViewer)
  {
  }

  virtual ~ViewBorderOperation() { }
    
  virtual void operator () (osg::Object*)
  {
    _compositeViewer->drawViewportBorder(_view.get());
  }
    
  osg::observer_ptr<osgViewer::View>    _view;
  FXOSGCompositeViewer*  _compositeViewer;
};

}

#endif
