#include "FXOSGViewer.h"

using namespace osgFOX;

FXDEFMAP(FXOSGViewer) FXOSGViewerMap[] = {
  FXMAPFUNC(SEL_PAINT, 0, FXOSGViewer::onPaint)
};

FXIMPLEMENT(FXOSGViewer, GraphicsWindowFOX, FXOSGViewerMap, ARRAYNUMBER(FXOSGViewerMap))

FXOSGViewer::FXOSGViewer(FXComposite *p,FXGLVisual *vis,FXObject *tgt,FXSelector sel,FXuint opts,FXint x,FXint y,FXint w,FXint h)
: GraphicsWindowFOX(p, vis, tgt, sel, opts, x, y, w, h)
{
  osg::GraphicsContext::setState(new osg::State);
  osg::GraphicsContext::getState()->setContextID(osg::GraphicsContext::createNewContextID());
  osgViewer::Viewer::setEventQueue(GraphicsWindowFOX::getEventQueue());
}

FXOSGViewer::FXOSGViewer(FXComposite *p,FXGLVisual *vis,FXGLCanvas *sharegroup,FXObject *tgt,FXSelector sel,FXuint opts,FXint x,FXint y,FXint w,FXint h)
: GraphicsWindowFOX(p, vis, tgt, sel, opts, x, y, w, h)
{
  osg::GraphicsContext::setState(new osg::State);
  osg::GraphicsContext::getState()->setContextID(osg::GraphicsContext::createNewContextID());
  osgViewer::Viewer::setEventQueue(GraphicsWindowFOX::getEventQueue());
}

FXOSGViewer::~FXOSGViewer()
{
  decrementContextIDUsageCount(osg::GraphicsContext::getState()->getContextID());
}

void FXOSGViewer::create()
{
  GraphicsWindowFOX::create();
}

long FXOSGViewer::onPaint(FXObject *,FXSelector,void *data)
{
  FXGLCanvas::makeCurrent();
  frame();
  FXGLCanvas::swapBuffers();
  FXGLCanvas::makeNonCurrent();
  return 1;
}
